package net.sf.sido.factory.support;

import com.google.common.base.Predicate;
import net.sf.sido.DataFactory;
import net.sf.sido.DataObject;
import net.sf.sido.DataSchema;
import net.sf.sido.array.Array;

import java.io.IOException;
import java.util.Map;

public class AnonymousArrayPropertyAssembler extends AbstractPropertyAssembler {

	public AnonymousArrayPropertyAssembler(String name) {
		super(name);
	}

    @Override
    public <T> void addProperty(DataFactory factory, PropertyAssemblerCallback callback, Map<String, DataSchema> schemas, Map<String, TypeDefinition> typeDefinitions, TypeDefinition definition, DataObject property) throws IOException {
		// Nullable
		boolean nullable = isNullable(property);
		// Constraint
		Predicate<Array<DataObject>> constraint = readConstraint(factory, property);
		// Adds the property
		definition.getBuilder().addAnonymousArrayProperty(name, nullable, constraint);
	}
}
