package net.sf.sido.io;

import net.sf.sido.DataObject;

/**
 * Defines how multiple references to a same {@link DataObject} must be handled when writing them
 * using a {@link DataObjectWriter}.
 * 
 * @author Damien Coraboeuf
 * 
 */
public enum DOReferenceManagement {

	/**
	 * List of references are taken only along a tree path (this is the default).
	 */
	STACK,

	/**
	 * List of references are taken globally into account, for the whole {@link DataObject} graph.
	 */
	GLOBAL;

}
