package net.sf.sido.support;

import java.util.HashMap;
import java.util.Map;

import net.sf.sido.DataObject;
import net.sf.sido.DataType;

public class DOCache {

	private final Map<String, DataObject> cache;

	public DOCache() {
		cache = new HashMap<String, DataObject>();
	}

	public DOCache(DOCache other) {
		cache = new HashMap<String, DataObject>(other.cache);
	}

	public boolean contains(DataObject o) {
		return contains(o.getSidoType(), o.getSidoId());
	}

	public boolean contains(DataType type, int id) {
		String key = getKey(type, id);
		return cache.containsKey(key);
	}

	public DataObject get(DataType type, int id) {
		String key = getKey(type, id);
		return cache.get(key);
	}

	private String getKey(DataType type, int id) {
		return type + "::" + id;
	}

	public void put(DataObject o) {
		put(o.getSidoId(), o);
	}

	public void put(int id, DataObject o) {
		String key = getKey(o.getSidoType(), id);
		cache.put(key, o);
	}

}
